﻿package
{
	//Import the necessary packages required
	import flash.events.EventDispatcher
	import flash.media.AudioDeviceManager;
	import flash.events.MouseEvent;
	import fl.controls.List;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.SharedObject;
	import flash.net.SharedObjectFlushStatus;
	import flash.media.AudioOutputChangeReason;
	import flash.events.AudioOutputChangeEvent;
	import flash.media.Sound;
	import flash.net.URLRequest;
	import flash.errors.IllegalOperationError;
	import flash.display.MovieClip;


	public class OutputSelection_persist extends MovieClip
	{
		//Initialize the variables
		var path:String = "AnimateCC.mp3";   // Place the AnimateCC.mp3 and the swf file in the same folder
		var mp3:Sound;
		var audio_device_manager:AudioDeviceManager;
		var device_names:Array;
		var obj:SharedObject;

		//Constructor
		public function OutputSelection_persist():void
		{
			listbox.setSize(300, 100);                 
			listbox.visible=false;
			obj = SharedObject.getLocal("SavedData");  // SavedData is the name of the LSO which will be created or read
			mp3 = new Sound();
			b.addEventListener(MouseEvent.CLICK, loadaudio); 
		}
		
		
		function loadaudio(event:MouseEvent):void
		{
			try
			{
				if (AudioDeviceManager.isSupported)        //check if the device supports AudioDeviceManager
				{
					audio_device_manager = AudioDeviceManager.audioDeviceManager;    //Initialize an instance of AudioDeviceManager
					
					if(obj.data.audio!=null)										//check if there is a name of an audio device in the LSO
				{
					for(var i:int =0 ;i<audio_device_manager.deviceNames.length;i++)
						{
							if(obj.data.audio == audio_device_manager.deviceNames[i])
								audio_device_manager.selectedDeviceIndex = i;		//set the audio device if the name stored in LSO matches to one of the device connected 
						}
				}
				mp3.load(new URLRequest(path));
				mp3.play();
				but.addEventListener(MouseEvent.CLICK, listdevices);
				b.removeEventListener(MouseEvent.CLICK, loadaudio);
				}
				else 
				trace("Audio Device Manager not supported");
			}catch(e:Error)
			{
				eve.text=e.message;
			}
		}
		function listdevices(event:MouseEvent):void
		{
				listbox.removeAll();
				audio_device_manager.addEventListener(AudioOutputChangeEvent.AUDIO_OUTPUT_CHANGE,audioOutputChangeHandler)  //listen for the Audio Output Change event
				listbox.visible = true;
				populate_audio_devices();
				listbox.addEventListener(Event.CHANGE, selected);
		}
		function selected(event:Event):void
		{
			try
			{   
				audio_device_manager.selectedDeviceIndex = event.target.selectedItem.data;  //User selected audio device from the list is set
			
			}catch(e:IllegalOperationError) {
				trace("error caught");
				eve.text="Illegal";
			}
		}	
		function populate_audio_devices():void
		{
			device_names = audio_device_manager.deviceNames;    // names of all the audio devices connected are returned in an array
			for (var i=0;i<device_names.length;i++)
			{
				trace(device_names[i]);
				listbox.addItem({label:device_names[i], data:i}); 
			}
					
		}
		function audioOutputChangeHandler(evt:AudioOutputChangeEvent):void
		{
			if (evt.reason == AudioOutputChangeReason.USER_SELECTION)   // check if reason code is USER_SELECTION
				{
					
					eve.text ="USER";
					index.text = "I=" +audio_device_manager.selectedDeviceIndex;
					try
					{
						obj.data.audio = audio_device_manager.deviceNames[audio_device_manager.selectedDeviceIndex];  //write in the LSO the name of the new device selected
						obj.flush();
					}catch(e:SharedObjectFlushStatus)
					{
						eve.text = "false";
					}
				
				} 
			else if (evt.reason == AudioOutputChangeReason.DEVICE_CHANGE)  //check if the reason code is DEVICE_CHANGE
				{

					eve.text = "DEVICE";
					index.text = "I=" +audio_device_manager.selectedDeviceIndex;
					
				}
		}

	}
}

